from StringIO import StringIO
from cgi import escape

def formToXML(form):
    """Takes a formulator form and serializes it to an XML representation.
    """
    id = form.getId()
    id = id + '.form'

    f = StringIO()
    write = f.write
    
    write('<?xml version="1.0" encoding="iso-8859-1"?>\n\n')
    write('<form>\n')
    # export form settings
    # XXX Should we be encoding some text?
    write('  <title>%s</title>\n' % escape(form.title))
    write('  <name>%s</name>\n' % escape(form.name))
    write('  <action>%s</action>\n' % form.action)
    write('  <enctype>%s</enctype>\n' % form.enctype)
    write('  <method>%s</method>\n' % form.method)
    write('  <pt>%s</pt>\n\n' % form.pt)
    # export form groups
    write('  <groups>\n')
    list_group = form.get_groups()
    #if type(list_group) is type([]):
    #  list_group.sort()
    for group in list_group:
        write('    <group>\n')
        write('      <title>%s</title>\n' % escape(group))
        write('      <fields>\n\n')
        list_field = form.get_fields_in_group(group)
        #if type(list_field) is type([]):
        #  list_field.sort(cmpfunc)
        for field in list_field:
            write('      <field><id>%s</id> <type>%s</type>\n' % (field.id, field.meta_type))
            write('        <values>\n')
            list_field_values_items = field.values.items()
            if type(list_field_values_items) is type([]):
              list_field_values_items.sort()
            for key, value in list_field_values_items:
                if value is None:
                    continue
                if callable(value):
                    write('          <%s type="method">%s</%s>\n' %
                                        (key, escape(str(value.method_name)), key))
                elif type(value) == type(1.1):
                    write('          <%s type="float">%s</%s>\n' % (key, escape(str(value)), key))
                elif type(value) == type(1):
                    write('          <%s type="int">%s</%s>\n' % (key, escape(str(value)), key))
                elif type(value) == type([]):
                    write('          <%s type="list">%s</%s>\n' % (key, escape(str(value)), key))
                else:
                    write('          <%s>%s</%s>\n' % (key, escape(str(value)), key))
            write('        </values>\n')
            write('        <tales>\n')
            list_field_tales_items = field.tales.items()
            if type(list_field_tales_items) is type([]):
              list_field_tales_items.sort()
            for key, value in list_field_tales_items:
                if value:
                    write('          <%s>%s</%s>\n' % (key, escape(str(value._text)), key))
            write('        </tales>\n')
            write('        <messages>\n')
            for message_key in field.get_error_names():
                write('          <message name="%s">%s</message>\n' %
                      (escape(message_key), escape(field.get_error_message(message_key))))
            write('        </messages>\n')
            write('      </field>\n')
        write('      </fields>\n')
        write('    </group>\n')
    write('  </groups>\n')
    write('</form>')

    return f.getvalue()

def cmpfunc(x,y):
  """
  This defines the compare function in order
  to sort list of objects
  """
  result = 0
  if x.id > y.id:
    result = 1
  elif y.id > x.id:
    result = -1
  return result
